<?php
ini_set('display_errors', 1);

require_once '../../resources/base_path_include.php';
require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources.'lib/validate_function.php';
require_once $base_path_to_learning.'branch_management/functions/functions.php';
require_once $base_path_to_learning.'user_management/authenticate.php';
require_once $base_path_to_learning.'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources.'includes/specific_db_config.php';


$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);die();
checkIfNoPhpContentsReceive();

if (!isset($postdata['institution_id']) or !checkIfIssetAndNotEmpty($postdata['institution_id']) or
 !isset($postdata['branch_id']) or !checkIfIssetAndNotEmpty($postdata['branch_id']) or !isset($postdata['class_id']) or !checkIfIssetAndNotEmpty($postdata['class_id']) or !isset($postdata['section_id']) or !checkIfIssetAndNotEmpty($postdata['section_id']) or !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or 
!isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or !isset($postdata['jwt_token']) or  !checkIfIssetAndNotEmpty($postdata['jwt_token'])) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is iin decodede data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id, null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}
function getClassIncharge($conn_rjllearning_specific,$institution_id,$branch_id,$class_id,$section_id, $limit, $offset) {
    
    $sql = "SELECT count(*) as total_rows FROM  class_incharge where institution_id =? ";
    $array_params = [$institution_id];
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result_total = $stmt->fetchAll();
    $totalrows = $result_total[0]['total_rows'];
  
    if($limit == 'all'){
        $sql_incharge = "SELECT * FROM  class_incharge where institution_id =?  and class_id = ? and section_id = ?";
         $array_params = [$institution_id,$class_id,$section_id];
        
    }else{
       
       $sql_incharge = "SELECT * FROM  class_incharge where institution_id = ? and class_id = ? and section_id = ?  LIMIT " . $offset . " ," . $limit . " ";
        $array_params = [$institution_id,$class_id,$section_id];
    }
    $stmt = $conn_rjllearning_specific->prepare($sql_incharge);
    $stmt->execute($array_params);
    $result = $stmt->fetchAll();
    // print_r($result);die();
   $array_return = array();
   foreach($result as $rows){
        
        $array_return[] =  array('incharge_id' => $rows['id'],'institution_id' => $rows['institution_id'],'branch_id' => $rows['branch_id'],'class_id' => $rows['class_id'],'section_id' => $rows['section_id'],'faculty_id' => $rows['faculty_id']);
    }
    
    
     if (count($result) < 50) {

        return array('total_rows' => $totalrows, 'incharge_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_rows' => $totalrows, 'incharge_info' => $array_return, 'maxreach' => 0);
    }
}

if($postdata['function_type']  == "fetch_class_incharge") {  
    
    $institution_id = trim($postdata['institution_id']);
    $branch_id = trim($postdata['branch_id']);
    $class_id = trim($postdata['class_id']);
    $section_id= trim($postdata['section_id']);
    $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific,$institution_id);
    if($check_academic_confirmation != true){
         errorreturn("Access denied. Academic session not active.");
    } 
    
    //  if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
    //     $search_string = trim($postdata['search_string']);
    // } else {
    //     $search_string = null;
    // }
    
    $limit = $postdata['limit'];

    $page = (isset($postdata['page']) and isNumeric($postdata['page'])) ? (int)$postdata['page'] : 1;
    if($limit != 'all'){
    $offset = ($page - 1) * $limit;
    $success['data'] = getClassIncharge($conn_rjllearning_specific,$institution_id,$branch_id,$class_id,$section_id, $limit, $offset);
    successreturn($success);
    }else{
    $success['data'] = getClassIncharge($conn_rjllearning_specific,$institution_id,$branch_id,$class_id,$section_id, $limit, null);
    successreturn($success);
        
    }
}

